local mod = ...


-- Building Asset Processor
mod:registerAssetProcessor("models/Weir1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/Weir1.fbx/Prefab/WeirPart/LogPart", "PREFAB_LOG")
mod:registerAssetId("models/Weir1.fbx/Prefab/WeirPart", "PREFAB_WEIR1")
mod:registerAssetId("models/Weir1.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_WEIR1")

mod:registerAssetId("models/Weir2.fbx/Prefab/WeirPart", "PREFAB_WEIR2")
mod:registerAssetId("models/Weir2.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_WEIR2")

mod:registerAssetId("models/Weir3.fbx/Prefab/WeirPart", "PREFAB_WEIR3")
mod:registerAssetId("models/Weir3.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_WEIR3")

mod:registerAssetId("models/Weir4.fbx/Prefab/WeirPart", "PREFAB_WEIR4")



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Weir1.fbx/Prefab/WeirPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/Weir2.fbx/Prefab/WeirPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/Weir3.fbx/Prefab/WeirPart", { "PLATFORM" })



-- Ground
mod:registerPrefabComponent("models/Weir1.fbx/Prefab/WeirPart", {
    DataType = "COMP_GROUNDED",
    GroundToWater = true
})

mod:registerPrefabComponent("models/Weir1.fbx/Prefab/ConstructionSteps", {
    DataType = "COMP_GROUNDED",
    GroundToWater = true
})

mod:registerPrefabComponent("models/Weir1.fbx/Prefab/WeirPart/Bucket.001", {
    DataType = "COMP_GROUNDED"
})



mod:registerPrefabComponent("models/Weir2.fbx/Prefab/WeirPart", {
    DataType = "COMP_GROUNDED",
    GroundToWater = true
})

mod:registerPrefabComponent("models/Weir2.fbx/Prefab/ConstructionSteps", {
    DataType = "COMP_GROUNDED",
    GroundToWater = true
})

mod:registerPrefabComponent("models/Weir2.fbx/Prefab/WeirPart/Bucket.001", {
    DataType = "COMP_GROUNDED"
})



mod:registerPrefabComponent("models/Weir3.fbx/Prefab/WeirPart", {
    DataType = "COMP_GROUNDED",
    GroundToWater = true
})

mod:registerPrefabComponent("models/Weir3.fbx/Prefab/ConstructionSteps", {
    DataType = "COMP_GROUNDED",
    GroundToWater = true
})

mod:registerPrefabComponent("models/Weir3.fbx/Prefab/WeirPart/Bucket.001", {
    DataType = "COMP_GROUNDED"
})



mod:registerPrefabComponent("models/Weir4.fbx/Prefab/WeirPart", {
    DataType = "COMP_GROUNDED",
    GroundToWater = true
})




-- Resource Container
-- mod:registerPrefabComponent("models/Weir1.fbx/Prefab/WeirPart", {
--     DataType = "COMP_RESOURCE_CONTAINER",
--     ResourceData = "FISH",
--     IsReplenishable = true,
--     ReplenishDurationInDays = 5,
--     ReplenishQuantity = 5,
--     AvailableQuantity = 5,
--     IsDestroyWhenEmpty = false
-- })



-- mod:registerPrefabComponent("models/Weir1.fbx/Prefab/WeirPart/COLLIDER", {
--     DataType = "COMP_GROUNDED"
-- })

-- mod:registerPrefabComponent("models/Weir1.fbx/Prefab/WeirPart/Stump.001", {
--     DataType = "COMP_GROUNDED"
-- })



-- Building: Fisher's Hut (override) -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FISHING_HUT",
	Name = "BUILDING_FISHING_HUT_NAME",
	Description = "FISHPOND_DESC",
    BuildingType = "GENERAL",
	AssetCoreBuildingPart = "LOG_PART",
	BuildingPartSetList = {
		{
			Name = "FISHING_SET1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_FISHING_HUT",
			}
        }, 
		{
			Name = "FISHING_SET2_NAME",
			BuildingPartList = { 
				"WEIR1_PART",
				"WEIR2_PART",
				"WEIR3_PART",
				"WEIR4_PART",
			}
        }
    },
	RequiredPartList = {
		{ Category = "CORE", Quantity = 1 }
	}
})



-- Building Part : Fisher's Hut (override) -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_PART_FISHING_HUT",
    Name = "BUILDING_PART_FISHING_HUT_NAME",
    Category = "CORE"
})



-- Building Part: Log -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "LOG_PART",
	Name = "BUILDING_FISHING_HUT_NAME", 
	Description = "BUILDING_FISHING_HUT_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_LOG"
	},
	IsVisibleWhenBuilt = false
})



-- Building part: Weir 1 (wicker weir) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
    Id = "WEIR1_PART",
    Name = "WEIR1_NAME",
    Category = "CORE",
    BuildingFunction = "FISHPOND1_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {7.5, 6.5}, {0.0, 2.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR =  false } 
            }
        }
    }, 
    ConstructionVisual = "PREFAB_CONSTR_WEIR1",
    ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_WEIR1"
        }, 
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "TOOL", Quantity = 1 }
		}
    }
})



-- Building part: Weir 2 (left bank long) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
    Id = "WEIR2_PART",
    Name = "WEIR2_NAME",
    Category = "CORE",
    BuildingFunction = "FISHPOND1_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {3.0, 4.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR =  false } 
            }, 
            { 
                Polygon = polygon.createRectangle( {2.0, 10.5}, {-2.0, 5.5} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR =  false } 
            }
        }
    }, 
    ConstructionVisual = "PREFAB_CONSTR_WEIR2",
    ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_WEIR2"
        }, 
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "TOOL", Quantity = 1 }
		}
    }
})



-- Building part: Weir 3 (right bank long) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
    Id = "WEIR3_PART",
    Name = "WEIR3_NAME",
    Category = "CORE",
    BuildingFunction = "FISHPOND1_FUNCTION",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {3.0, 4.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR =  false } 
            }, 
            { 
                Polygon = polygon.createRectangle( {2.0, 10.5}, {2.0, 5.5} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR =  false } 
            }
        }
    }, 
    ConstructionVisual = "PREFAB_CONSTR_WEIR3",
    ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_WEIR3"
        }, 
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "TOOL", Quantity = 1 }
		}
    }
})



-- Building part: Weir 4 (decorative weir) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
    Id = "WEIR4_PART",
    Name = "WEIR4_NAME",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.0, 6.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR =  false } 
            }
        }
    }, 
    -- ConstructionVisual = "PREFAB_CONSTR_WEIR4",
    ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_WEIR4"
        }, 
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
		-- UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		-- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 10 },
        --     { Resource = "TOOL", Quantity = 1 }
		-- }
    }
})



-- Building Function: Fish Pond (1 worker) -------------------------------------------------------------------------------------
-- Same code as in the Fish Pond mod (keep name the same)

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "FISHPOND1_FUNCTION",
    Name = "FISHPOND1_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "FISHERMAN", 
        Behavior = "WORK_BEHAVIOR"
    },
    ResourceProduced = {{ Resource = "FISH", Quantity = 1 }}
})


